Summary: A free implementation of the Kerberos 5 network security system.
Name: shishi
Version: 1.0.0
Release: 1
Source0: ftp://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.gz
Source1: ftp://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.gz.sig
Patch0: %{name}-%{version}-aix.patch
Patch1: %{name}-%{version}-aix51.patch
Patch2: %{name}-%{version}-aix52.patch
Group: System Environment/Libraries
License: LGPLv2+
URL: http://www.gnu.org/software/shishi/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: gettext-devel >= 0.17
BuildRequires: libgcrypt-devel >= 1.4.5
BuildRequires: gnutls-devel >= 2.6.6
BuildRequires: libgpg-error-devel >= 1.7
BuildRequires: libtasn1-devel >= 2.2
Requires: gettext >= 0.17
Requires: libgcrypt >= 1.4.5
Requires: gnutls >= 2.6.6
Requires: libgpg-error >= 1.7
Requires: libtasn1 >= 2.2

%ifos aix5.1
Requires: prngd
%endif

%description
Shishi is an implementation of the Kerberos 5 network authentication system,
as specified in RFC 4120. Shishi can be used to authenticate users in
distributed systems.

Shishi contains a library ('libshishi') that can be used by application
developers to add support for Kerberos 5. Shishi contains a command line
utility ('shishi') that is used by users to acquire and manage tickets
(and more). The server side, a Key Distribution Center, is implemented by
'shishid'. Of course, a manual documenting usage aspects as well as the
programming API is included.

Shishi currently supports AS/TGS exchanges for acquiring tickets,
pre-authentication, the AP exchange for performing client and server
authentication, and SAFE/PRIV for integrity/privacy protected application
data exchanges.

Most, if not all, of the widely used encryption and checksum types are
supported, such as 3DES, AES, ARCFOUR and HMAC-SHA1.

The library is available as 32-bit and 64-bit.


%package devel
Summary: Development libraries and header files for %{name}
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: /sbin/install-info, info
Requires: pkg-config

%description devel
Shishi is an implementation of the Kerberos 5 network authentication system,
as specified in RFC 4120. Shishi can be used to authenticate users in
distributed systems.

This package contains the header files and libraries needed to write 
or compile programs that use %{name}.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "cc -q64" or "gcc -maix64".


%prep
%setup -q
%patch0
%ifos aix5.1
%patch1
%else
%patch2
%endif


%build
# setup environment for 32-bit and 64-bit builds
export AR="ar -X32_64"
export NM="nm -X32_64"

# first build the 64-bit version
export CC="cc -qcpluscmt -q64"
./configure \
    --prefix=%{_prefix} \
    --sysconfdir=/etc \
    --localstatedir=/var \
    --infodir=%{_infodir} \
    --mandir=%{_mandir} \
    --enable-shared --enable-static \
    --enable-random-device \
    --enable-pseudo-random-device \
    --with-libgcrypt \
    --with-system-asn1
exit
make %{?_smp_mflags}

cp ./db/.libs/libshisa.so.0 .
cp ./lib/.libs/libshishi.so.0 .
make distclean

# now build the 32-bit version
export CC="cc -qcpluscmt"
./configure \
    --prefix=%{_prefix} \
    --sysconfdir=/etc \
    --localstatedir=/var \
    --infodir=%{_infodir} \
    --mandir=%{_mandir} \
    --enable-shared --enable-static \
    --enable-random-device \
    --enable-pseudo-random-device \
    --with-libgcrypt \
    --with-system-asn1
make %{?_smp_mflags}

# add the 64-bit shared objects to the shared library containing already the
# 32-bit shared objects
${AR} -q ./db/.libs/libshisa.a ./libshisa.so.0
${AR} -q ./lib/.libs/libshishi.a ./libshishi.so.0


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
make DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip ${RPM_BUILD_ROOT}%{_bindir}/* || :

rm -f ${RPM_BUILD_ROOT}%{_infodir}/dir
gzip --best ${RPM_BUILD_ROOT}%{_infodir}/*.info

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin sbin include lib
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%post devel
/sbin/install-info %{_infodir}/%{name}.info.gz %{_infodir}/dir || :


%preun devel
if [ $1 = 0 ]; then
    /sbin/install-info --delete %{_infodir}/%{name}.info.gz %{_infodir}/dir || :
fi


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc AUTHORS COPYING README NEWS
%{_bindir}/*
%{_sbindir}/*
%{_libdir}/*.a
%dir %{_libdir}/security
%{_libdir}/security/*.a
%{_mandir}/man1/*
%{_datadir}/locale/*
%dir /etc/%{name}
%config /etc/%{name}/shisa.conf
%config /etc/%{name}/%{name}.conf
%config /etc/%{name}/%{name}.skel
%dir /var/%{name}
/usr/bin/*
/usr/sbin/*
/usr/lib/*.a


%files devel
%defattr(-,root,system)
%{_includedir}/*
%{_libdir}/*.la
%{_libdir}/pkgconfig/%{name}.pc
%{_infodir}/%{name}*info*
%{_mandir}/man3/*
/usr/include/*
/usr/lib/*.la


%changelog
* Fri May 21 2010 Michael Perzl <michael@perzl.org> - 1.0.0-1
- first version for AIX V5.1 and higher
